#!/usr/bin/env python3
import io
import json

from PyPDF2 import PdfFileReader, PdfFileWriter, __version__ as pypdf_version


def split(pdf_data, split_info):
    result = {}
    src_buffer = io.BytesIO(pdf_data)
    src_buffer.seek(0)
    src_pdf = PdfFileReader(src_buffer, strict=False, overwriteWarnings=False)
    last_page = src_pdf.getNumPages()
    for fn in split_info:
        start, end = split_info[fn]
        if end == 'end':
            end = last_page
        pdf_writer = PdfFileWriter()
        for page in range(int(start) - 1, int(end)):
            pdf_writer.addPage(src_pdf.getPage(page))
        tmp_io = io.BytesIO()
        pdf_writer.write(tmp_io)
        tmp_io.seek(0)
        split_data = tmp_io.read()
        result[fn] = split_data

    return result


def main():
    print(pypdf_version)
    with open('test.pdf', 'rb') as f_pdf, open('test_split.json') as f_json:
        split_info = json.load(f_json)
        pdf_data = f_pdf.read()
    split(pdf_data, split_info)


if __name__ == '__main__':
    main()
